#include "include.h"   
  

int ancien_genre;

/*********************************************************************************************************/


/*********************************************************************************************************/

void init_fractal(genre)   
int genre;
{
pt_en_cours=0;
switch(genre) {
	case MANDELBROT :
		symetrie=1;
		if (!initcoord) {
			z0.re=-2.25;
			z0.im=1.4;
			z1.re=1.25;
			z1.im=-1.4;
		}
		bailout=4.0;
		break;
	
	case JULIA :
		symetrie=2;
		if (!initcoord) {
			z0.re=-2.0;
			z0.im=1.6;
			z1.re=2.0;
			z1.im=-1.6;
		}
		if (((cz.re==0.0)&&(cz.im==0.0))||(ancien_genre!=MANDELBROT)) {
			cz.re=-0.75;
			cz.im=0.17;
			}
		bailout=4.0;
		break;
		
	case MANDEL3 :
		symetrie=1;
		if (!initcoord) {
			z0.re=-2.0;
			z0.im=1.6;
			z1.re=2.0;
			z1.im=-1.6;
		}
		bailout=4;
		break;
		
	case NEWTON :
		symetrie=1;
		if (ip==0) ip=3;
		if (!initcoord) {
			z0.re=-2.0;
			z0.im=1.6;
			z1.re=2.0;
			z1.im=-1.6;
		}
		break;  

	case JULIA3 :
		symetrie=0;         
		if (!initcoord) {
			z0.re=-2.0;
			z0.im=1.6;
			z1.re=2.0;
			z1.im=-1.6;
		}
		if (((cz.re==0.0)&&(cz.im==0.0))||(ancien_genre!=MANDEL3)) {
			cz.re=-0.52;
			cz.im=0.1;
		}
		bailout=4;
		break;  

	case LAMBDA :
		symetrie=0;
		if (!initcoord) {
			z0.re=-1.5;
			z0.im=1.6;
			z1.re=2.5;
			z1.im=-1.6;
		}
		if (((cz.re==0.0)&&(cz.im==0.0))||(ancien_genre!=MANDELLAMBDA)) {
		cz.re=-0.2393;
		cz.im=1.0507;}
		bailout=16.0;
		break;
		
	case MANDELLAMBDA :
		symetrie=1;
		if (!initcoord) {
			z0.re=-2.3;
			z0.im=2.625;
			z1.re=4.3;
			z1.im=-2.65;
		}
		bailout=16.0;
		break;

	case SPIDER :
		symetrie=1;
		if (!initcoord) {
			z0.re=-2.0;
			z0.im=1.6;
			z1.re=2.0;
			z1.im=-1.6;
		}
		/*if ((cz.re==0.0)&&(cz.im==0.0)) */
		cz.re=0;
		cz.im=0;
		bailout=4;
		break;
		
	case BARNSLEY1 :
		symetrie=0;
		if (!initcoord) {
			z0.re=-2.0;
			z0.im=1.6;
			z1.re=2.0;
			z1.im=-1.6;
		}
		/*if ((cz.re==0.0)&&(cz.im==0.0)) */
		cz.re=0;
		cz.im=0;
		bailout=4;
		break;
		
	case BARNSLEY2 :
		symetrie=0;
		if (!initcoord) {
			z0.re=-2.0;
			z0.im=1.6;
			z1.re=2.0;
			z1.im=-1.6;
		}
		/*if ((cz.re==0.0)&&(cz.im==0.0)) */
		cz.re=0;
		cz.im=0;
		bailout=4;
		break;
		
	case BARNSLEY3 :
		symetrie=2;
		if (!initcoord) {
			z0.re=-2.0;
			z0.im=1.6;
			z1.re=2.0;
			z1.im=-1.6;
		}
		/*if ((cz.re==0.0)&&(cz.im==0.0)) */
		cz.re=0;
		cz.im=0;
		bailout=4;
		break;
		
/*	case GLASS :
		symetrie=0;
		if (!initcoord) {
		z0=lcomplx((FLOAT_SIZE)-2.0,(FLOAT_SIZE)1.6);
		z1=lcomplx((FLOAT_SIZE)2.0,(FLOAT_SIZE)-1.6);
		}
		if ((cz.re==0.0)&&(cz.im==0.0)) 
		cz=lcomplx((FLOAT_SIZE)0.0,(FLOAT_SIZE)0.0); 
		bailout=4;
		break;*/
		
	case JCOS :
		symetrie=0;
		if (!initcoord) {
			z0.re=-2.0;
			z0.im=1.6;
			z1.re=2.0;
			z1.im=-1.6;
		}
		/*if ((cz.re==0.0)&&(cz.im==0.0)) */
		cz.re=0;
		cz.im=0;
		bailout=4;
		break;
		
	case JSIN :
		symetrie=0;
		if (!initcoord) {
			z0.re=-2.0;
			z0.im=1.6;
			z1.re=2.0;
			z1.im=-1.6;
		}
		/*if ((cz.re==0.0)&&(cz.im==0.0)) */
		cz.re=0;
		cz.im=0;
		bailout=4;
		break;
		
	case JEXP :
		symetrie=0;
		if (!initcoord) {
			z0.re=-2.0;
			z0.im=1.6;
			z1.re=2.0;
			z1.im=-1.6;
		}
		/*if ((cz.re==0.0)&&(cz.im==0.0)) */
		cz.re=0;
		cz.im=0;
		bailout=4;
		break;
		
	case NOEL1 :
		symetrie=0;
		if (!initcoord) {
			z0.re=-2.0;
			z0.im=1.6;
			z1.re=2.0;
			z1.im=-1.6;
		}
		/*if ((cz.re==0.0)&&(cz.im==0.0))*/ 
		cz.re=0;
		cz.im=0;
		bailout=4;
		break;
		
	case NOEL2 :
		symetrie=0;
		if (!initcoord) {
			z0.re=-2.0;
			z0.im=1.6;
			z1.re=2.0;
			z1.im=-1.6;
		}
		/*if ((cz.re==0.0)&&(cz.im==0.0)) */
		cz.re=0;
		cz.im=0;
		bailout=4;
		break;
		
	case PHOENIX :
		symetrie=0;
		if (!initcoord) {
			z0.re=-2.0;
			z0.im=1.6;
			z1.re=2.0;
			z1.im=-1.6;
		}
		/*if ((cz.re==0.0)&&(cz.im==0.0)) */
		cz.re=0;
		cz.im=0;
		bailout=4;
		break;
		
	case TETRATE :
		symetrie=0;
		if (!initcoord) {
			z0.re=-2.0;
			z0.im=1.6;
			z1.re=2.0;
			z1.im=-1.6;
		}
		if ((cz.re==0.0)&&(cz.im==0.0)) 
		cz.re=0;
		cz.im=0;
		bailout=4;
		break;
		

		
	}
	initcoord=FALSE;
}

/*******************************************************************************************************************************/

int  calcul3(z)  
lcomplex z;
{
int k;   
int img;

switch (genre) {
	case MANDELBROT :
		k=lmandelbrot(z); 
		break;  
	default:                         
		k=lmandelbrot(z); 
	}

return(k);

}

/*******************************************************************************************************************************/

int  calcul2(z)  
complex z;
{
int k;   
int img;
complex cz1;

cz1.re=(double)cz.re;
cz1.im=(double)cz.im;
       
switch (genre) {
	case MANDELBROT :
		k=mandelbrot(z); 
		break;  
	case JULIA :
		k=julia(z,cz1);  
		break;    
	case MANDEL3 :
		k=mandel3(z);
		break;     
	case NEWTON  :
		k=newton(z);
		break;             
	case JULIA3  :
		k=julia3(z,cz);
		break;    	
	case LAMBDA  :
		k=lambda(z,cz1);
		break;    
	case MANDELLAMBDA  :
		k=mandellambda(z);
		break;    
	case SPIDER :
		k=spider(z,cz1);
		break; 
	case BARNSLEY1 :
		k=barnsley1(z,cz1);
		break;   
	case BARNSLEY2 :
		k=barnsley2(z,cz1);
		break;   
	case BARNSLEY3 :
		k=barnsley3(z,cz1);
		break;   
	case GLASS :
		k=glass(z,cz1);
		break;
	case JCOS :
		k=jcos(z,cz1);
		break;
	case JSIN :
		k=jsin(z,cz1);
		break;
	case JEXP :
		k=jexp(z,cz1);
		break;
	case NOEL1 :
		k=noel1(z,cz1);
		break;
	case NOEL2 :
		k=noel2(z,cz1);
		break;
	case PHOENIX :
		k=phoenix(z,cz1);
		break;
	case TETRATE :
		k=tetrate(z,cz1);
		break;
	default:                         
		k=mandelbrot(z); 
	}
/*if (k==iter) {k=0;}   */
return(k);

}
/**************************************************************************************/
/******************************************************************************************************************************/  


void Change_genre(w, client_data, call_data)
     Widget   w;
     char    *client_data;
     XtPointer  call_data;
{     
int selec=FALSE;
char numero[100];
pt_en_cours=0;
 
ancien_genre=genre;
   
if (strcmp(client_data,"Mandelbrot")==0) {
	genre=MANDELBROT;
	selec=TRUE;
}

if (strcmp(client_data,"Julia")==0) {
	genre=JULIA;
	selec=TRUE;
}

if (strcmp(client_data,"Newton")==0) {
	genre=NEWTON;
	selec=TRUE;
}

if (strcmp(client_data,"Lambda")==0) {
	genre=LAMBDA;
	selec=TRUE;
}

if (strcmp(client_data,"Mandellambda")==0) {
	genre=MANDELLAMBDA;
	selec=TRUE;
}

if (strcmp(client_data,"Spider")==0) {
	genre=SPIDER;
	selec=TRUE;
}

if (strcmp(client_data,"Barnsley1")==0) {
	genre=BARNSLEY1;
	selec=TRUE;
}

if (strcmp(client_data,"Barnsley2")==0) {
	genre=BARNSLEY2;
	selec=TRUE;
}

if (strcmp(client_data,"Barnsley3")==0) {
	genre=BARNSLEY3;
	selec=TRUE;
}

if (strcmp(client_data,"Glass")==0) {
	genre=GLASS;
	selec=TRUE;
}

if (strcmp(client_data,"Jcos")==0) {
	genre=JCOS;
	selec=TRUE;
}

if (strcmp(client_data,"Jsin")==0) {
	genre=JSIN;
	selec=TRUE;
}

if (strcmp(client_data,"Jexp")==0) {
	genre=JEXP;
	selec=TRUE;
}

if (strcmp(client_data,"Noel1")==0) {
	genre=NOEL1;
	selec=TRUE;
}

if (strcmp(client_data,"Noel2")==0) {
	genre=NOEL2;
	selec=TRUE;
}

if (strcmp(client_data,"Phoenix")==0) {
	genre=PHOENIX;
	selec=TRUE;
}

if (strcmp(client_data,"Tetrate")==0) {
	genre=TETRATE;
	selec=TRUE;
}

if (selec) {
/*	init0(genre);
	if (initfractal) init_fractal(genre);    */
	init_fractal(genre); 
	sprintf(numero,"Nouveau type : %s",client_data);
	ecrire(numero);
	}

}
/******************************************************************************************************************************/  

